# coding=utf8

# Copyright 2018 JDCLOUD.COM
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# NOTE: This class is auto generated by the jdcloud code generator program.

from jdcloud_sdk.core.jdcloudrequest import JDCloudRequest


class DescribeImagesRequest(JDCloudRequest):
    """
    查询服务配置信息，提供详细的 master 和 node 镜像信息。
    """

    def __init__(self, parameters, header=None, version="v1"):
        super(DescribeImagesRequest, self).__init__(
            '/regions/{regionId}/images', 'GET', header, version)
        self.parameters = parameters


class DescribeImagesParameters(object):

    def __init__(self, regionId, ):
        """
        :param regionId: Region ID
        """

        self.regionId = regionId
        self.masterVersion = None
        self.masterImageCode = None

    def setMasterVersion(self, masterVersion):
        """
        :param masterVersion: (Optional) 集群的大版本，如 1.8.12
        """
        self.masterVersion = masterVersion

    def setMasterImageCode(self, masterImageCode):
        """
        :param masterImageCode: (Optional) master 的镜像编码，如 1.8.12-jke
        """
        self.masterImageCode = masterImageCode

